#!/bin/sh
##
### Script zur Steuerung der HTTPD-Traffik-Ermittlung
########## created: Wed May  7 13:11:34 2008 ###
FIND="/usr/bin/find"
RM="/bin/rm"
GREP="/bin/grep"
PREFIX="---USER_PREFIX---";
HOMEDIR="/var/www"
BACKUPDIR="/var/log/apache2/old"
LOGEXPIRE="90"
PIDFILE="/usr/share/confixx/run/confixx_httpdtraffik.pid" # PID-File
SCRIPT="/usr/share/confixx/httpdtraffik.pl" # Das Script, das den Traffik ermittelt anhand des ConfigFiles (und natuerlich Logfile;-)
ROTATESCRIPT="/usr/share/confixx/rotate.pl" # Das Script, das die Logfiles packt...
CONF=".configs/webalizer.conf"
WEBALIZER="---BIN_WEBALIZER---"
AWSTATS="---BOOL_AWSTATS---"
AWSTATS_CONF_DIR="/etc/awstats"
AWSTATS_SCRIPT="/usr/lib/cgi-bin/awstats.pl"
########################
if test "$1" =  "DEBUG"  ; then
  DEBUG=1;
 else
  DEBUG=0;
fi

echo $$ > $PIDFILE;
      for HOME in $HOMEDIR/* ; do
        USER=${HOME##$HOMEDIR/}
        if ( echo -E "X$USER" | $GREP "^X$PREFIX[0-9]\+$" >/dev/null )  ; then
          if test "$DEBUG" = "1"; then
            echo "$USER"
          fi
          if ((test "$USER" != "*") && (test -e "$HOME/log/access_log") && (test "1$USER" != "1")); then
            if test "$DEBUG" = "1"; then
              echo "$SCRIPT $USER"
            fi
            $SCRIPT $USER
            if ((test -e $HOMEDIR/$USER/$CONF) && (test -x "$WEBALIZER")) ; then
              if test "$DEBUG" = "1"; then
                echo "$WEBALIZER -c $HOMEDIR/$USER/$CONF"
              fi
              $WEBALIZER -c $HOMEDIR/$USER/$CONF
            fi
            if ( (test $AWSTATS = "1" ) && (test -e $AWSTATS_CONF_DIR/awstats.$USER.conf) && (test -x "$AWSTATS_SCRIPT")) ; then
              if test "$DEBUG" = "1"; then
                echo "$AWSTATS_SCRIPT  -config=$USER -update"
              fi
              $AWSTATS_SCRIPT  -config=$USER -update >/dev/null
            fi

            if test "$DEBUG" = "1"; then
              echo "$ROTATESCRIPT $USER access"
            fi
           $ROTATESCRIPT $USER access
            if(test -d $BACKUPDIR/$USER) ; then
              if test "$DEBUG" = "1"; then
              echo "$FIND $BACKUPDIR/$USER/ -atime +$LOGEXPIRE -type f -exec rm -f {} \;"
              fi
              $FIND $BACKUPDIR/$USER/ -atime +$LOGEXPIRE -type f -exec rm -f {} \;
            fi
            if(test -d $HOMEDIR/$USER/log/old) ; then
              if test "$DEBUG" = "1"; then
                echo "$FIND $HOMEDIR/$USER/log/old/ -atime +$LOGEXPIRE -type f -exec rm -f {} \;"
              fi
              $FIND $HOMEDIR/$USER/log/old/ -atime +$LOGEXPIRE -type f -exec rm -f {} \;
            fi
          fi
        fi
      done
rm $PIDFILE; # Bin fertig, also PID-File loeschen...
