<?
/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once( dirname(__FILE__) . "/class.NameDataField.php" );





class OneValueDataField extends NameDataField {

	/* -------------------- Members -------------------- */
	var $ms_Value; // value of field
	/* -------------------- end Members -------------------- */





	/* -------------------- Constructor -------------------- */
	function OneValueDataField( $ps_Value="", $ps_Name=NULL, $paAttributes = array(), $paParentAttributes = array() ) {
		$this->NameDataField( $ps_Name, $paAttributes, $paParentAttributes );
		$this->SetValue( $ps_Value );
	}
	/* -------------------- end Constructor -------------------- */





	/* -------------------- Set.../Get... -------------------- */
	function SetValue( $ps_Value ) {
		$this->ms_Value = $ps_Value;
	}

	function GetValue() {
		return $this->ms_Value;
	}
	/* -------------------- end Set.../Get... -------------------- */





	/* -------------------- SetFromArray -------------------- */
	function SetFromArray( &$pa_Data ) {
		$ls_Name = $this->GetName();
		if( is_null( $ls_Name ) )
			return;
		$this->SetValue( array_key_exists( $ls_Name, $pa_Data ) ? $pa_Data[$ls_Name] : NULL );
	}
	/* -------------------- end SetFromArray -------------------- */

}
?>
